The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Guitar Class Reference

STK guitar model class. More...

`#include <Guitar.h>`

Inheritance diagram for stk::Guitar:

## Public Member Functions
| Guitar (unsigned int nStrings=6, std::string bodyfile="")
| Class constructor, specifying an arbitrary number of strings (default = 6).
void | clear (void)
| Reset and clear all internal state.
void | setBodyFile (std::string bodyfile="")
| Set the string excitation, using either a soundfile or computed noise. More...
void | setPluckPosition (StkFloat position, int string=-1)
| Set the pluck position for one or all strings. More...
void | setLoopGain (StkFloat gain, int string=-1)
| Set the loop gain for one or all strings. More...
void | setFrequency (StkFloat frequency, unsigned int string=0)
| Set instrument parameters for a particular frequency.
void | noteOn (StkFloat frequency, StkFloat amplitude, unsigned int string=0)
| Start a note with the given frequency and amplitude. More...
void | noteOff (StkFloat amplitude, unsigned int string=0)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value, int string=-1)
| Perform the control change specified by number and value (0.0 - 128.0). More...
StkFloat | lastOut (void)
| Return the last computed output value.
StkFloat | tick (StkFloat input=0.0)
| Take an optional input sample and compute one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the `iFrames` object as inputs to the class and write outputs to the `oFrames` object. More...
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the effect and write outputs to the `oFrames` object. More...
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK guitar model class.

This class implements a guitar model with an arbitrary number of strings (specified during instantiation). Each string is represented by an stk::Twang object. The model supports commuted synthesis, as discussed by Smith and Karjalainen. It also includes a basic body coupling model and supports feedback.

This class does not attempt voice management. Rather, most functions support a parameter to specify a particular string number and string (voice) management is assumed to occur externally. Note that this class does not inherit from stk::Instrmnt because of API inconsistencies.

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others.

Control Change Numbers:

- Bridge Coupling Gain = 2
- Pluck Position = 4
- Loop Gain = 11
- Coupling Filter Pole = 1
- Pick Filter Pole = 128

by Gary P. Scavone, 2012.

## Member Function Documentation

## ◆ setBodyFile()

void stk::Guitar::setBodyFile | ( | std::string | bodyfile = `""` | ) |

Set the string excitation, using either a soundfile or computed noise.

If no argument is provided, the std::string is empty, or an error occurs reading the file data, an enveloped noise signal will be generated for use as the pluck excitation.

## ◆ setPluckPosition()

void stk::Guitar::setPluckPosition | ( | StkFloat | position,
|  | int | string = `-1`
| ) |  |

Set the pluck position for one or all strings.

If the `string` argument is < 0, the pluck position is set for all strings.

## ◆ setLoopGain()

void stk::Guitar::setLoopGain | ( | StkFloat | gain,
|  | int | string = `-1`
| ) |  |

Set the loop gain for one or all strings.

If the `string` argument is < 0, the loop gain is set for all strings.

## ◆ noteOn()

void stk::Guitar::noteOn | ( | StkFloat | frequency,
|  | StkFloat | amplitude,
|  | unsigned int | string = `0`
| ) |  |

Start a note with the given frequency and amplitude.

If the `amplitude` parameter is less than 0.2, the string will be undamped but it will not be "plucked."

## ◆ controlChange()

void stk::Guitar::controlChange | ( | int | number,
|  | StkFloat | value,
|  | int | string = `-1`
| ) |  |

Perform the control change specified by number and value (0.0 - 128.0).

If the `string` argument is < 0, then the control change is applied to all strings (if appropriate).

## ◆ tick() [1/2]

StkFrames & stk::Guitar::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the class and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

163 {
164 #if defined(_STK_DEBUG_)
165 if ( channel >= frames.channels() ) {
166 oStream_ << "Guitar::tick(): channel and StkFrames arguments are incompatible!";
167 handleError( StkError::FUNCTION_ARGUMENT );
168 }
169 #endif
170
171 StkFloat *samples = &frames[channel];
172 unsigned int hop = frames.channels();
173 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
174 *samples = tick( *samples );
175
176 return frames;
177 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.
stk::Guitar::tick
StkFloat tick(StkFloat input=0.0)
Take an optional input sample and compute one output sample.
Definition: Guitar.h:135

## ◆ tick() [2/2]

StkFrames & stk::Guitar::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the effect and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

180 {
181 #if defined(_STK_DEBUG_)
182 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
183 oStream_ << "Guitar::tick(): channel and StkFrames arguments are incompatible!";
184 handleError( StkError::FUNCTION_ARGUMENT );
185 }
186 #endif
187
188 StkFloat *iSamples = &iFrames[iChannel];
189 StkFloat *oSamples = &oFrames[oChannel];
190 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
191 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop )
192 *oSamples = tick( *iSamples );
193
194 return iFrames;
195 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.
stk::Guitar::tick
StkFloat tick(StkFloat input=0.0)
Take an optional input sample and compute one output sample.
Definition: Guitar.h:135

The documentation for this class was generated from the following file:

- Guitar.h

The Synthesis ToolKit in C++ (STK)
©1995--2019 Perry R. Cook and Gary P. Scavone. All Rights Reserved.